/*
Authorization Service API v. 1.0

<a href='https://cern.service-now.com/service-portal?id=privacy_policy&se=SSO-Service&notice=resources'>Privacy notice</a>

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package authzapiv1

import (
	"encoding/json"
)

// checks if the AccountScopeAssignment type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AccountScopeAssignment{}

// AccountScopeAssignment struct for AccountScopeAssignment
type AccountScopeAssignment struct {
	AccountId *string `json:"accountId,omitempty"`
	ScopeId   *string `json:"scopeId,omitempty"`
	Applied   *bool   `json:"applied,omitempty"`
	Builtin   *bool   `json:"builtin,omitempty"`
}

// NewAccountScopeAssignment instantiates a new AccountScopeAssignment object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAccountScopeAssignment() *AccountScopeAssignment {
	this := AccountScopeAssignment{}
	return &this
}

// NewAccountScopeAssignmentWithDefaults instantiates a new AccountScopeAssignment object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAccountScopeAssignmentWithDefaults() *AccountScopeAssignment {
	this := AccountScopeAssignment{}
	return &this
}

// GetAccountId returns the AccountId field value if set, zero value otherwise.
func (o *AccountScopeAssignment) GetAccountId() string {
	if o == nil || IsNil(o.AccountId) {
		var ret string
		return ret
	}
	return *o.AccountId
}

// GetAccountIdOk returns a tuple with the AccountId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AccountScopeAssignment) GetAccountIdOk() (*string, bool) {
	if o == nil || IsNil(o.AccountId) {
		return nil, false
	}
	return o.AccountId, true
}

// HasAccountId returns a boolean if a field has been set.
func (o *AccountScopeAssignment) HasAccountId() bool {
	if o != nil && !IsNil(o.AccountId) {
		return true
	}

	return false
}

// SetAccountId gets a reference to the given string and assigns it to the AccountId field.
func (o *AccountScopeAssignment) SetAccountId(v string) {
	o.AccountId = &v
}

// GetScopeId returns the ScopeId field value if set, zero value otherwise.
func (o *AccountScopeAssignment) GetScopeId() string {
	if o == nil || IsNil(o.ScopeId) {
		var ret string
		return ret
	}
	return *o.ScopeId
}

// GetScopeIdOk returns a tuple with the ScopeId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AccountScopeAssignment) GetScopeIdOk() (*string, bool) {
	if o == nil || IsNil(o.ScopeId) {
		return nil, false
	}
	return o.ScopeId, true
}

// HasScopeId returns a boolean if a field has been set.
func (o *AccountScopeAssignment) HasScopeId() bool {
	if o != nil && !IsNil(o.ScopeId) {
		return true
	}

	return false
}

// SetScopeId gets a reference to the given string and assigns it to the ScopeId field.
func (o *AccountScopeAssignment) SetScopeId(v string) {
	o.ScopeId = &v
}

// GetApplied returns the Applied field value if set, zero value otherwise.
func (o *AccountScopeAssignment) GetApplied() bool {
	if o == nil || IsNil(o.Applied) {
		var ret bool
		return ret
	}
	return *o.Applied
}

// GetAppliedOk returns a tuple with the Applied field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AccountScopeAssignment) GetAppliedOk() (*bool, bool) {
	if o == nil || IsNil(o.Applied) {
		return nil, false
	}
	return o.Applied, true
}

// HasApplied returns a boolean if a field has been set.
func (o *AccountScopeAssignment) HasApplied() bool {
	if o != nil && !IsNil(o.Applied) {
		return true
	}

	return false
}

// SetApplied gets a reference to the given bool and assigns it to the Applied field.
func (o *AccountScopeAssignment) SetApplied(v bool) {
	o.Applied = &v
}

// GetBuiltin returns the Builtin field value if set, zero value otherwise.
func (o *AccountScopeAssignment) GetBuiltin() bool {
	if o == nil || IsNil(o.Builtin) {
		var ret bool
		return ret
	}
	return *o.Builtin
}

// GetBuiltinOk returns a tuple with the Builtin field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AccountScopeAssignment) GetBuiltinOk() (*bool, bool) {
	if o == nil || IsNil(o.Builtin) {
		return nil, false
	}
	return o.Builtin, true
}

// HasBuiltin returns a boolean if a field has been set.
func (o *AccountScopeAssignment) HasBuiltin() bool {
	if o != nil && !IsNil(o.Builtin) {
		return true
	}

	return false
}

// SetBuiltin gets a reference to the given bool and assigns it to the Builtin field.
func (o *AccountScopeAssignment) SetBuiltin(v bool) {
	o.Builtin = &v
}

func (o AccountScopeAssignment) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AccountScopeAssignment) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.AccountId) {
		toSerialize["accountId"] = o.AccountId
	}
	if !IsNil(o.ScopeId) {
		toSerialize["scopeId"] = o.ScopeId
	}
	if !IsNil(o.Applied) {
		toSerialize["applied"] = o.Applied
	}
	if !IsNil(o.Builtin) {
		toSerialize["builtin"] = o.Builtin
	}
	return toSerialize, nil
}

type NullableAccountScopeAssignment struct {
	value *AccountScopeAssignment
	isSet bool
}

func (v NullableAccountScopeAssignment) Get() *AccountScopeAssignment {
	return v.value
}

func (v *NullableAccountScopeAssignment) Set(val *AccountScopeAssignment) {
	v.value = val
	v.isSet = true
}

func (v NullableAccountScopeAssignment) IsSet() bool {
	return v.isSet
}

func (v *NullableAccountScopeAssignment) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAccountScopeAssignment(val *AccountScopeAssignment) *NullableAccountScopeAssignment {
	return &NullableAccountScopeAssignment{value: val, isSet: true}
}

func (v NullableAccountScopeAssignment) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAccountScopeAssignment) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
